#ifndef ENGINE_INCLUDED
#define ENGINE_INCLUDED

#include <math.h>

#include "TForm.hh"

#include "EDriver.hh"

class Engine
{
public:
  Engine(EDriver &rDriver);
  ~Engine(void);

  void TriFace(TCoord rC1, TCoord rC2, TCoord rC3,
	       TexC t1, TexC t2, TexC t3);

  void FlatBottomRast(int blX, int blZ, TexC blTC, int brX, int brZ, TexC brTC, int bY, int tX, int tY, int tZ, TexC tTC,
		      EPIXEL pixColor);

  void FlatTopRast(int bX, int bY, int bZ, TexC bTC, int tlX, int tlZ, TexC tlTC, int trX, int trZ, TexC trTC, int tY, 
		   EPIXEL pixColor);
  

  void LeftBrokenRast(int bX, int bY, int bZ, TexC bTC, int lBrknX, int lBrknY, int lBrknZ, TexC lBrknTC, int tX, int tY, int tZ, TexC tTC,
		      EPIXEL pixColor);

  void RightBrokenRast(int bX, int bY, int bZ, TexC bTC, int rBrknX, int rBrknY, int rBrknZ, TexC rBrknTC, int tX, int tY, int tZ, TexC tTC,
		       EPIXEL pixColor);

  //void Test(void);

  //?hack? these are wrappers of driver functions.  I generally don't like wrappering..
  void ClearFB(void);
  void ClearDB(void);
  void UpLoadTexture(Texture &rTexture, unsigned textureID);
  void SetCTexture(unsigned cTextureID);
  void Flush(void);

  void PushTForm(TForm addTForm);
  void ClearTForm(void); //sets to identity

protected:

  EDriver *pDriver;

  inline long RI(float in)
  {
    return static_cast<long>(rint( in) );
  };

  //unsigned cID; //useful for debugging if set to special texture

  TForm tForm;
};

#endif //ENGINE_INCLUDED
