#ifndef TCOORD_INCLUDED
#define TCOORD_INCLUDED

#include <ostream>

class TCoord
{
public:
  TCoord(void);
  TCoord(float tX, float tY, float tZ);
  TCoord(const TCoord &rhs);
  virtual ~TCoord(void);

  const TCoord& operator=(const TCoord &rhs);

  void Normalize(void);
  float Mag(void) const;

  friend const TCoord& operator*=(TCoord &lhs, const float scale);
  friend const TCoord& operator+=(TCoord &lhs, const TCoord &rhs);
  
  friend TCoord operator+(const TCoord &lhs, const TCoord &rhs);
  friend TCoord operator-(const TCoord &lhs, const TCoord &rhs);

  //cross product
  friend TCoord operator%(const TCoord &lhs, const TCoord &rhs);
  //dot product
  friend float operator*(const TCoord &lhs, const TCoord &rhs);

  float x,y,z;
};

std::ostream& operator<<(std::ostream &rout, TCoord &rCoord);

#endif //TCOORD_INCLUDED
