#include <math.h>

#include "TForm.hh"

TForm::TForm(void)
{}

TForm::~TForm(void)
{}


TForm CreateIdentity(void)
{
  TForm res;

  res.m[0][0] = 1.0;
  res.m[0][1] = 0.0;
  res.m[0][2] = 0.0;
  res.m[0][3] = 0.0;

  res.m[1][0] = 0.0;
  res.m[1][1] = 1.0;
  res.m[1][2] = 0.0;
  res.m[1][3] = 0.0;

  res.m[2][0] = 0.0;
  res.m[2][1] = 0.0;
  res.m[2][2] = 1.0;
  res.m[2][3] = 0.0;

  res.m[3][0] = 0.0;
  res.m[3][1] = 0.0;
  res.m[3][2] = 0.0;
  res.m[3][3] = 1.0;

  return res;
}

TForm CreateScale(float scale)
{
  TForm res = CreateIdentity();;

  res.m[0][0] = scale;
  res.m[1][1] = scale;
  res.m[2][2] = scale;
  //res.m[3][3] = scale;

  return res;
}

TForm CreateRevY(void)
{
  TForm res = CreateIdentity();

  res.m[1][1] = -1.0;

  return res;
}


TForm CreateRotX(float angRad)
{
  float cosA = cos(angRad);
  float sinA = sin(angRad);

  TForm res = CreateIdentity();

  res.m[1][1] = cosA;
  res.m[1][2] = -sinA;
  res.m[2][1] = sinA;
  res.m[2][2] = cosA;

  return res;
}

TForm CreateRotY(float angRad)
{
  float cosA = cos(angRad);
  float sinA = sin(angRad);

  TForm res = CreateIdentity();

  res.m[0][0] = cosA;
  res.m[0][2] = sinA;
  res.m[2][0] = -sinA;
  res.m[2][2] = cosA;

  return res;
}

TForm CreateRotZ(float angRad)
{
  float cosA = cos(angRad);
  float sinA = sin(angRad);

  TForm res = CreateIdentity();

  res.m[0][0] = cosA;
  res.m[0][1] = -sinA;
  res.m[1][0] = sinA;
  res.m[1][1] = cosA;

  return res;
}

TForm CreateOffset(float xOffset, float yOffset, float zOffset)
{
  TForm res = CreateIdentity();

  res.m[0][3] = xOffset;
  res.m[1][3] = yOffset;
  res.m[2][3] = zOffset;

  return res;
}

TForm operator*(const TForm &lhs, const TForm &rhs)
{
  TForm res;

  for(unsigned cRow = 0; cRow < 4; cRow++)
    for(unsigned cCol = 0; cCol < 4; cCol++)
      {
	float sum = 0;

	for(unsigned ii = 0; ii < 4; ii++)
	  sum += lhs.m[cRow][ii]*rhs.m[ii][cCol];

	res.m[cRow][cCol] = sum;
      }

  /*
  res.m[0][0] = lhs.m[0][0]*rhs.m[0][0] + lhs.m[0][1]*rhs.m[1][0] + lhs.m[0][2]*rhs.m[2][0] + lhs.m[0][3]*rhs.m[3][0];
  res.m[0][1] = lhs.m[1][0]*rhs.m[0][0] + lhs.m[1][1]*rhs.m[1][0] + lhs.m[1][2]*rhs.m[2][0] + lhs.m[1][3]*rhs.m[3][0];
  res.m[0][2] = lhs.m[2][0]*rhs.m[0][0] + lhs.m[2][1]*rhs.m[1][0] + lhs.m[2][2]*rhs.m[2][0] + lhs.m[2][3]*rhs.m[3][0];
  res.m[0][3] = lhs.m[3][0]*rhs.m[0][0] + lhs.m[3][1]*rhs.m[1][0] + lhs.m[3][2]*rhs.m[2][0] + lhs.m[3][3]*rhs.m[3][0];

  res.m[1][0] = lhs.m[0][0]*rhs.m[0][1] + lhs.m[0][1]*rhs.m[1][1] + lhs.m[0][2]*rhs.m[2][1] + lhs.m[0][3]*rhs.m[3][1];
  res.m[1][1] = lhs.m[1][0]*rhs.m[0][1] + lhs.m[1][1]*rhs.m[1][1] + lhs.m[1][2]*rhs.m[2][1] + lhs.m[1][3]*rhs.m[3][1];
  res.m[1][2] = lhs.m[2][0]*rhs.m[0][1] + lhs.m[2][1]*rhs.m[1][1] + lhs.m[2][2]*rhs.m[2][1] + lhs.m[2][3]*rhs.m[3][1];
  res.m[1][3] = lhs.m[3][0]*rhs.m[0][1] + lhs.m[3][1]*rhs.m[1][1] + lhs.m[3][2]*rhs.m[2][1] + lhs.m[3][3]*rhs.m[3][1];

  res.m[2][0] = lhs.m[0][0]*rhs.m[0][2] + lhs.m[0][1]*rhs.m[1][2] + lhs.m[0][2]*rhs.m[2][2] + lhs.m[0][3]*rhs.m[3][2];
  res.m[2][1] = lhs.m[1][0]*rhs.m[0][2] + lhs.m[1][1]*rhs.m[1][2] + lhs.m[1][2]*rhs.m[2][2] + lhs.m[1][3]*rhs.m[3][2];
  res.m[2][2] = lhs.m[2][0]*rhs.m[0][2] + lhs.m[2][1]*rhs.m[1][2] + lhs.m[2][2]*rhs.m[2][2] + lhs.m[2][3]*rhs.m[3][2];
  res.m[2][3] = lhs.m[3][0]*rhs.m[0][2] + lhs.m[3][1]*rhs.m[1][2] + lhs.m[3][2]*rhs.m[2][2] + lhs.m[3][3]*rhs.m[3][2];

  res.m[3][0] = lhs.m[0][0]*rhs.m[0][3] + lhs.m[0][1]*rhs.m[1][3] + lhs.m[0][2]*rhs.m[2][3] + lhs.m[0][3]*rhs.m[3][3];
  res.m[3][1] = lhs.m[1][0]*rhs.m[0][3] + lhs.m[1][1]*rhs.m[1][3] + lhs.m[1][2]*rhs.m[2][3] + lhs.m[1][3]*rhs.m[3][3];
  res.m[3][2] = lhs.m[2][0]*rhs.m[0][3] + lhs.m[2][1]*rhs.m[1][3] + lhs.m[2][2]*rhs.m[2][3] + lhs.m[2][3]*rhs.m[3][3];
  res.m[3][3] = lhs.m[3][0]*rhs.m[0][3] + lhs.m[3][1]*rhs.m[1][3] + lhs.m[3][2]*rhs.m[2][3] + lhs.m[3][3]*rhs.m[3][3];
  */
  return res;
}

TCoord operator*(const TForm &tform, const TCoord coord)
{
  TCoord res;

  res.x = tform.m[0][0]*coord.x + tform.m[0][1]*coord.y + tform.m[0][2]*coord.z + tform.m[0][3]*1.00;
  res.y = tform.m[1][0]*coord.x + tform.m[1][1]*coord.y + tform.m[1][2]*coord.z + tform.m[1][3]*1.00;
  res.z = tform.m[2][0]*coord.x + tform.m[2][1]*coord.y + tform.m[2][2]*coord.z + tform.m[2][3]*1.00;

  return res;
}

std::ostream& operator<<(std::ostream &out, TForm &rTform)
{
  for(unsigned cRow = 0; cRow < 4; cRow++)
    {
      for(unsigned cCol = 0; cCol < 4; cCol++)
	{
	  out << rTform.m[cRow][cCol] << "     ";
	}
      out << '\n';
    }

  return out;
}
