#include <iostream>
#include <iomanip>

#include "EPPPort.hh"
#include "TvcDriver.hh"
#include "Engine.hh"
#include "DemoUnit.hh"

using namespace std;

int DoMenu(void)
{
  while(true)
    {
      cout << "enter 1 for blank" << endl;
      cout << "enter 2 for multi-color blank" << endl;
      cout << "enter 3 for lines" << endl;
      cout << "enter 4 for teapot single" << endl;
      cout << "enter 5 for teapot spin" << endl;
      cout << "enter 6 for test scanline" << endl;
      cout << "enter 7 for quit" << endl;

      int sel = 0;
      cin >> sel;
      if(sel <= 0 || sel > 7)
	{
	  cout << "print unknown selection\n\n" << endl;
	  continue;
	};

      return sel;
    };
};

TexC junkC(0.0,0.0);

int main(void)
{
  EPPPort port;
  if( !port.Initialize() ) return -1;

  if( port.CheckAndClearTimeout() )
    {
      cout << "initial timeout set" << endl;
    };
  port.WriteAddress(0);
  port.CheckAndClearTimeout();

  //port.TestDataLinkQuality();
  //return 0;

  TvcDriver driver(port);
  driver.PrintStatus();

  driver.DumpRegisters(); 

  //driver.WriteValue(0, 0xFF00FF33);

  //unsigned long jvalue;
  //driver.ReadValue(0, jvalue);

  // driver.PrintStatus();

  //driver.DumpRegisters();

  //unsigned long result = 0;
  //driver.ReadValue(0, result);
  //driver.DumpRegisters();

  //cout << "result: " << hex << result << dec << endl;
  //return 0;

  Engine engine(driver);
  DemoUnit demos(engine);
  if( !demos.Init() ) return -1;

  bool done = false;
  do
    { 
      int sel = DoMenu();
      switch(sel)
	{
	case 1:
	  driver.Blank();
	  break;
	case 2:
	  cout << "starting red fill" << endl;
	  driver.Blank(0xC0);
	  cout << "starting green fill" << endl;
	  driver.Blank(0x38);
	  cout << "starting blue fill" << endl;
	  driver.Blank(0x07);
	  cout << "starting white fill" << endl;
	  driver.Blank(0xff);
	  cout << "starting blank" << endl;
	  driver.Blank();
	  break;
	case 3:
	  cout << "drawing lines" << endl;
	  driver.DrawLine(0,0, 640,480, 0xFF);
	  driver.DrawLine(640,0, 0,480, 0xC0); 
	  driver.DrawLine(0,480/2, 640,480/2, 0x38);
	  driver.DrawLine(640/2,0, 640/2,480, 0x07); 
	  //driver.DrawLine(640/2,0, 640/2,480, 0x07);
	  //driver.DrawLine(640/2+1,0, 640/2+1,480, 0x07);
	  //driver.DrawLine(640/2+2,0, 640/2+2,480, 0x07);
	  //driver.DrawLine(640/2+3,0, 640/2+3,480, 0x07);
	  //driver.DrawLine(640/2+4,0, 640/2+4,480, 0x07);
	  
	  break;
	case 4:
	  demos.TeapotDisplaySingle();
	  break;
	case 5:
	  demos.TeapotRotateAboutY();
	  break;
	case 6:
	  driver.PolyScanLine( 100, 0, 101, 0, 100, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 102, 0, 102, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 103, 0, 104, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 104, 0, 106, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 105, 0, 108, junkC,junkC, 0xFFFFFFFF);
	  //driver.PolyScanLine( 100, 0, 106, 0, 110, 0xFFFFFFFF);
	  /*
	  driver.PolyScanLine( 100, 0, 107, 0, 112, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 108, 0, 114, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 109, 0, 116, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 110, 0, 118, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 111, 0, 120, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 112, 0, 122, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 113, 0, 124, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 114, 0, 126, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 115, 0, 128, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 116, 0, 130, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 117, 0, 132, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 118, 0, 134, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 119, 0, 136, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 120, 0, 138, 0xFFFFFFFF);
	  */
	  break;
	default:
	  done = true;
	};
    }while(!done);
  
  if( port.CheckAndClearTimeout() )
    {
      cout << "final timeout set" << endl;
    }else
      cout << "final timeout NOT set" << endl;

  port.CloseAll();
  return 0;
}
