
#include <iostream>

using namespace std;

unsigned DoMult(unsigned char n1, unsigned char n2)
{
  unsigned res = 0;

  for(unsigned ii = 0; ii < 8; ii++)
    {
      unsigned cBitMask = 0x1<<ii;

      if( cBitMask & n2 )
	res += (unsigned)n1 << ii;
    };

  return res;
}

//optimized to only need a single bit shift per loop
unsigned DoMult2(unsigned char n1, unsigned char n2)
{
  unsigned res = 0;

  unsigned n1_full = n1;

  for(unsigned ii = 0; ii < 8; ii++)
    {
      unsigned cBitMask = 0x1<<ii;

      if( cBitMask & n2 )
	res += n1_full;

      n1_full = n1_full << 0x1;
    };

  return res;
}

int main(void)
{

  unsigned char n1 = 0;
  while(true)
    {
      unsigned char n2 = 0;
      while(true)
	{

	  unsigned res1 = DoMult2(n1, n2);
	  unsigned res2 = (unsigned)n1 * (unsigned)n2;

	  if( res1 != res2)
	    {
	      cout << "error! n1: " << (int)n1 << " n2: " << (int)n2 << " computed: " << res1 << endl;
	    }//else
	  //cout << "success! n1: " << (int)n1 << " n2: " << (int)n2 << endl;

	  unsigned char nextN2 = n2 +1;
	  if( nextN2 < n2 ) break; //rollover to zero

	  n2 = nextN2;
	};

      unsigned char nextN1 = n1 +1;
      if( nextN1 < n1 ) break; //rollover

      n1 = nextN1;
    };

  cout << "done!" << endl;
  return 0;
};
